package Apache::MirrorCapabilities;
# file Apache/MirrorCapabilities.pm 
#  capacities of CTAN mirrors 
#  generated from mirror_capabilities.pl 
use Exporter;
@ISA = ('Exporter');
@EXPORT = qw(@mirrors 
	      %mirror_data 
	      $mirror_popup_labels
	      &mirror_FTP_path &mirror_geo &mirror_services &mirror_offers);

@mirrors = ("ctan.unsw.edu.au",
   "ftp.univie.ac.at",
   "gd.tuwien.ac.at",
   "ftp.belnet.be",
   "scratchy.emate.ucr.ac.cr",
   "sunsite.auc.dk",
   "ftp.gwdg.de",
   "ftp.informatik.uni-hamburg.de",
   "ftp.mpi-sb.mpg.de",
   "ftp.tu-chemnitz.de",
   "ftp.uni-augsburg.de",
   "ftp.uni-bielefeld.de",
   "ftp.uni-mainz.de",
   "ftp.uni-stuttgart.de",
   "ftp.ut.ee",
   "ftp.funet.fi",
   "guinness.domicile.fr",
   "ftp.jussieu.fr",
   "ftp.loria.fr",
   "ftp.oleane.net",
   "ftp.uvsq.fr",
   "ftp.ntua.gr",
   "ftp.comp.hkbu.edu.hk",
   "ftp.sztaki.hu",
   "ftp.heanet.ie",
   "cis.uniRoma2.it",
   "ftp.unina.it",
   "ftp.lab.kdd.co.jp",
   "ftp.meisei-u.ac.jp",
   "ftp.riken.go.jp",
   "ftp.u-aizu.ac.jp",
   "mirror.nucba.ac.jp",
   "sunsite.sut.ac.jp",
   "ftp.kreonet.re.kr",
   "ftp.ntg.nl",
   "sunsite.icm.edu.pl",
   "ftp.chg.ru",
   "ftp.nus.edu.sg",
   "sunsite.uakom.sk",
   "ftp.rediris.es",
   "ftp.sunsite.kth.se",
   "sunsite.cnlab-switch.ch",
   "ftp.ccu.edu.tw",
   "ftp.nctu.edu.tw",
   "sunsite.bilkent.edu.tr",
   "sunsite.doc.ic.ac.uk",
   "ctan.math.utah.edu",
   "ftp.freesoftware.com",
   "ftp.cise.ufl.edu",
   "ftp.duke.edu",
   "ftp.rge.com",
   "ftp.sunsite.utk.edu",
   "jhcloos.com",
   "sunsite.unc.edu",
   "wuarchive.wustl.edu",
   "ftp.dante.de",
   "ftp.tex.ac.uk",
   "tug.ctan.org");

%mirror_data = ("ctan.unsw.edu.au" => ["/tex-archive", "NSW, Australia", [ "tar.gz" ] ],
    "ftp.univie.ac.at" => ["/packages/tex", "Austria", [ "tar.gz" ] ],
    "gd.tuwien.ac.at" => ["/publishing/tex/CTAN", "Austria", [ "tar.gz" ] ],
    "ftp.belnet.be" => ["/packages/TeX", "Belgium", [ "tar.gz" ] ],
    "scratchy.emate.ucr.ac.cr" => ["/pub/ctan", "Costa Rica", [ "zip", "tar.gz" ] ],
    "sunsite.auc.dk" => ["/pub/tex/ctan", "Denmark", [  ] ],
    "ftp.gwdg.de" => ["/pub/dante", "Germany", [ "tar.gz" ] ],
    "ftp.informatik.uni-hamburg.de" => ["/tex-archive", "Germany", [ "zip", "tar.gz" ] ],
    "ftp.mpi-sb.mpg.de" => ["/pub/tex/mirror/ftp.dante.de", "Germany", [  ] ],
    "ftp.tu-chemnitz.de" => ["/pub/tex", "Germany", [  ] ],
    "ftp.uni-augsburg.de" => ["/pub/tex/ctan", "Germany", [ "tar.gz" ] ],
    "ftp.uni-bielefeld.de" => ["/pub/tex", "Germany", [ "tar.gz" ] ],
    "ftp.uni-mainz.de" => ["/pub/tex", "Germany", [ "zip", "tar.gz" ] ],
    "ftp.uni-stuttgart.de" => ["/tex-archive", "Germany", [ "zip", "tar.gz" ] ],
    "ftp.ut.ee" => ["/tex-archive", "Estonia", [  ] ],
    "ftp.funet.fi" => ["/pub/TeX/CTAN", "Finland", [  ] ],
    "guinness.domicile.fr" => ["/pub/CTAN", "France", [  ] ],
    "ftp.jussieu.fr" => ["/pub4/TeX/CTAN", "France", [ "tar.gz" ] ],
    "ftp.loria.fr" => ["/pub/ctan", "France", [ "zip", "tar.gz" ] ],
    "ftp.oleane.net" => ["/pub/mirrors/CTAN/", "France", [  ] ],
    "ftp.uvsq.fr" => ["/pub/TeX/CTAN", "France", [ "tar.gz" ] ],
    "ftp.ntua.gr" => ["/mirror/ctan", "Greece", [  ] ],
    "ftp.comp.hkbu.edu.hk" => ["/pub/TeX/CTAN", "Hong Kong", [ "tar.gz" ] ],
    "ftp.sztaki.hu" => ["/pub/tex", "Hungary", [  ] ],
    "ftp.heanet.ie" => ["/pub/ctan/tex", "Ireland", [  ] ],
    "cis.uniRoma2.it" => ["/TeX", "Italy", [  ] ],
    "ftp.unina.it" => ["/pub/TeX", "Italy", [ "tar.gz" ] ],
    "ftp.lab.kdd.co.jp" => ["/CTAN", "Japan", [  ] ],
    "ftp.meisei-u.ac.jp" => ["/pub/CTAN", "Japan", [  ] ],
    "ftp.riken.go.jp" => ["/pub/tex-archive", "Japan", [ "tar.gz" ] ],
    "ftp.u-aizu.ac.jp" => ["/pub/tex/CTAN", "Japan", [ "tar.gz" ] ],
    "mirror.nucba.ac.jp" => ["/mirror/TeX", "Japan", [ "tar.gz" ] ],
    "sunsite.sut.ac.jp" => ["/pub/archives/ctan", "Japan", [  ] ],
    "ftp.kreonet.re.kr" => ["/pub/CTAN", "Korea", [ "tar.gz" ] ],
    "ftp.ntg.nl" => ["/pub/tex-archive", "The Netherlands", [ "zip", "tar.gz" ] ],
    "sunsite.icm.edu.pl" => ["/pub/CTAN", "Poland", [ "tar.gz" ] ],
    "ftp.chg.ru" => ["/pub/TeX/CTAN", "Russia", [ "tar.gz" ] ],
    "ftp.nus.edu.sg" => ["/pub/docs/TeX", "Singapore", [ "tar.gz" ] ],
    "sunsite.uakom.sk" => ["/pub/mirrors/CTAN", "Slovak Republic", [  ] ],
    "ftp.rediris.es" => ["/mirror/tex-archive", "Spain", [ "tar.gz" ] ],
    "ftp.sunsite.kth.se" => ["/pub/tex", "Sweden", [ "tar.gz" ] ],
    "sunsite.cnlab-switch.ch" => ["/ftp/mirror/tex", "Switzerland", [  ] ],
    "ftp.ccu.edu.tw" => ["/pub/tex", "Taiwan", [  ] ],
    "ftp.nctu.edu.tw" => ["/pub/tex", "Taiwan", [  ] ],
    "sunsite.bilkent.edu.tr" => ["/pub/tex/ctan", "Turkey", [ "zip", "tar.gz" ] ],
    "sunsite.doc.ic.ac.uk" => ["/packages/tex/uk-tex", "UK", [  ] ],
    "ctan.math.utah.edu" => ["/tex-archive", "Utah, USA", [ "zip", "tar.gz" ] ],
    "ftp.freesoftware.com" => ["/pub/tex/ctan", "West coast, USA", [  ] ],
    "ftp.cise.ufl.edu" => ["/tex-archive", "Florida, USA", [ "zip", "tar.gz" ] ],
    "ftp.duke.edu" => ["/tex-archive", "North Carolina, USA", [ "tar.gz" ] ],
    "ftp.rge.com" => ["/pub/tex", "New York, USA", [ "tar.gz" ] ],
    "ftp.sunsite.utk.edu" => ["/pub/CTAN", "Tennessee, USA", [  ] ],
    "jhcloos.com" => ["/pub/mirror/tex-archive", "Texas, USA", [  ] ],
    "sunsite.unc.edu" => ["/pub/packages/TeX", "North Carolina, USA", [ "tar.gz" ] ],
    "wuarchive.wustl.edu" => ["/packages/TeX", "Missouri, USA", [  ] ],
    "ftp.dante.de" => ["/tex-archive", "Mainz, Germany", [ "zip", "tar.gz" ] ],
    "ftp.tex.ac.uk" => ["/tex-archive", "Cambridge, UK", [ "zip", "tar.gz" ] ],
    "tug.ctan.org" => ["/tex-archive", "Colchester, Vermont, USA", [ "zip", "tar.gz" ] ]);

$mirror_popup_labels = {
"ctan.unsw.edu.au" => "ctan.unsw.edu.au (NSW, Australia)   tar.gz",
    "ftp.univie.ac.at" => "ftp.univie.ac.at (Austria)   tar.gz",
    "gd.tuwien.ac.at" => "gd.tuwien.ac.at (Austria)   tar.gz",
    "ftp.belnet.be" => "ftp.belnet.be (Belgium)   tar.gz",
    "scratchy.emate.ucr.ac.cr" => "scratchy.emate.ucr.ac.cr (Costa Rica)   zip tar.gz",
    "sunsite.auc.dk" => "sunsite.auc.dk (Denmark)  ",
    "ftp.gwdg.de" => "ftp.gwdg.de (Germany)   tar.gz",
    "ftp.informatik.uni-hamburg.de" => "ftp.informatik.uni-hamburg.de (Germany)   zip tar.gz",
    "ftp.mpi-sb.mpg.de" => "ftp.mpi-sb.mpg.de (Germany)  ",
    "ftp.tu-chemnitz.de" => "ftp.tu-chemnitz.de (Germany)  ",
    "ftp.uni-augsburg.de" => "ftp.uni-augsburg.de (Germany)   tar.gz",
    "ftp.uni-bielefeld.de" => "ftp.uni-bielefeld.de (Germany)   tar.gz",
    "ftp.uni-mainz.de" => "ftp.uni-mainz.de (Germany)   zip tar.gz",
    "ftp.uni-stuttgart.de" => "ftp.uni-stuttgart.de (Germany)   zip tar.gz",
    "ftp.ut.ee" => "ftp.ut.ee (Estonia)  ",
    "ftp.funet.fi" => "ftp.funet.fi (Finland)  ",
    "guinness.domicile.fr" => "guinness.domicile.fr (France)  ",
    "ftp.jussieu.fr" => "ftp.jussieu.fr (France)   tar.gz",
    "ftp.loria.fr" => "ftp.loria.fr (France)   zip tar.gz",
    "ftp.oleane.net" => "ftp.oleane.net (France)  ",
    "ftp.uvsq.fr" => "ftp.uvsq.fr (France)   tar.gz",
    "ftp.ntua.gr" => "ftp.ntua.gr (Greece)  ",
    "ftp.comp.hkbu.edu.hk" => "ftp.comp.hkbu.edu.hk (Hong Kong)   tar.gz",
    "ftp.sztaki.hu" => "ftp.sztaki.hu (Hungary)  ",
    "ftp.heanet.ie" => "ftp.heanet.ie (Ireland)  ",
    "cis.uniRoma2.it" => "cis.uniRoma2.it (Italy)  ",
    "ftp.unina.it" => "ftp.unina.it (Italy)   tar.gz",
    "ftp.lab.kdd.co.jp" => "ftp.lab.kdd.co.jp (Japan)  ",
    "ftp.meisei-u.ac.jp" => "ftp.meisei-u.ac.jp (Japan)  ",
    "ftp.riken.go.jp" => "ftp.riken.go.jp (Japan)   tar.gz",
    "ftp.u-aizu.ac.jp" => "ftp.u-aizu.ac.jp (Japan)   tar.gz",
    "mirror.nucba.ac.jp" => "mirror.nucba.ac.jp (Japan)   tar.gz",
    "sunsite.sut.ac.jp" => "sunsite.sut.ac.jp (Japan)  ",
    "ftp.kreonet.re.kr" => "ftp.kreonet.re.kr (Korea)   tar.gz",
    "ftp.ntg.nl" => "ftp.ntg.nl (The Netherlands)   zip tar.gz",
    "sunsite.icm.edu.pl" => "sunsite.icm.edu.pl (Poland)   tar.gz",
    "ftp.chg.ru" => "ftp.chg.ru (Russia)   tar.gz",
    "ftp.nus.edu.sg" => "ftp.nus.edu.sg (Singapore)   tar.gz",
    "sunsite.uakom.sk" => "sunsite.uakom.sk (Slovak Republic)  ",
    "ftp.rediris.es" => "ftp.rediris.es (Spain)   tar.gz",
    "ftp.sunsite.kth.se" => "ftp.sunsite.kth.se (Sweden)   tar.gz",
    "sunsite.cnlab-switch.ch" => "sunsite.cnlab-switch.ch (Switzerland)  ",
    "ftp.ccu.edu.tw" => "ftp.ccu.edu.tw (Taiwan)  ",
    "ftp.nctu.edu.tw" => "ftp.nctu.edu.tw (Taiwan)  ",
    "sunsite.bilkent.edu.tr" => "sunsite.bilkent.edu.tr (Turkey)   zip tar.gz",
    "sunsite.doc.ic.ac.uk" => "sunsite.doc.ic.ac.uk (UK)  ",
    "ctan.math.utah.edu" => "ctan.math.utah.edu (Utah, USA)   zip tar.gz",
    "ftp.freesoftware.com" => "ftp.freesoftware.com (West coast, USA)  ",
    "ftp.cise.ufl.edu" => "ftp.cise.ufl.edu (Florida, USA)   zip tar.gz",
    "ftp.duke.edu" => "ftp.duke.edu (North Carolina, USA)   tar.gz",
    "ftp.rge.com" => "ftp.rge.com (New York, USA)   tar.gz",
    "ftp.sunsite.utk.edu" => "ftp.sunsite.utk.edu (Tennessee, USA)  ",
    "jhcloos.com" => "jhcloos.com (Texas, USA)  ",
    "sunsite.unc.edu" => "sunsite.unc.edu (North Carolina, USA)   tar.gz",
    "wuarchive.wustl.edu" => "wuarchive.wustl.edu (Missouri, USA)  ",
    "ftp.dante.de" => "ftp.dante.de (Mainz, Germany)   zip tar.gz",
    "ftp.tex.ac.uk" => "ftp.tex.ac.uk (Cambridge, UK)   zip tar.gz",
    "tug.ctan.org" => "tug.ctan.org (Colchester, Vermont, USA)  zip tar.gz  "
};

# Functions using that data

# mirror_FTP_path from the mirror, get the path to the top of the FTP TeX tree
sub mirror_FTP_path {
    my $mirror = shift();

    if (exists($mirror_data{$mirror})) {
	return $mirror_data{$mirror}[0];
    } else {
	return undef;
    }
}

# mirror_geo from the mirror, get its geographic info
sub mirror_geo {
    my $mirror = shift();

    if (exists($mirror_data{$mirror})) {
	return $mirror_data{$mirror}[1];
    } else {
	return undef;
    }
}


# Mirror_offers:  predicate, given mirror and string, return 1 or 0
sub mirror_offers {
    my ($mirror,$desired_service) = @_;

    my @services = ();
    if (defined (@services = mirror_services($mirror))) {
        foreach $service (@services) {
	    if ($service eq $desired_service) {
		return 1;
	    }
	}
	return 0;
    } else {
	return 0; # not even any such mirror
    }
}


# mirror_services: give a list of services offered 
sub mirror_services {
    my $mirror = shift();

    if (exists($mirror_data{$mirror})) {
	return @{$mirror_data{$mirror}[2]};
    } else {
	return ();
    }
}


1;
